       subroutine blii3d(x,y,z,f,xi,yi,zi,fi,fxi,fyi,fzi,
     & fxyi,fxzi,fyzi,fxyzi)
	  
c***********************************************************************
c      Barycentric Linear Interpolation 3D
c      Written by Orlando Camargo Rodriguez
c      orodrig@ualg.pt
c      Universidade do Algarve
c      Physics Department
c      Signal Processing Laboratory
c      Gambelas, Wed Jun 15 13:00:00 WEST 2011
c***********************************************************************

       real*8 f(2,2,2)
       real*8 x(2),y(2),z(2)
       real*8 px(2),py(2),pz(2)
       real*8 pxyz
       real*8 fi,fxi,fyi,fzi,fxyi,fxzi,fyzi,fxyzi
       real*8 xi,x1,x2
       real*8 yi,y1,y2
       real*8 zi,z1,z2
       real*8      a112,a121,a122
       real*8 a211,a212,a221,a222

       x1 = x(1)
       x2 = x(2)
       
       y1 = y(1)
       y2 = y(2)
       
       z1 = z(1)
       z2 = z(2)

       pxyz = (x2-x1)*(y2-y1)*(z2-z1)

       a112 = (f(1,1,2)-f(1,1,1))/pxyz
       a121 = (f(1,2,1)-f(1,1,1))/pxyz
       a122 = (f(1,1,1)-f(1,2,2))/pxyz
       a211 = (f(2,1,1)-f(1,1,1))/pxyz
       a212 = (f(1,1,1)-f(2,1,2))/pxyz
       a221 = (f(1,1,1)-f(2,2,1))/pxyz
       a222 = (f(2,2,2)-f(1,1,1))/pxyz
       
       px(1) = xi - x1
       px(2) = xi - x2
       py(1) = yi - y1
       py(2) = yi - y2
       pz(1) = zi - z1
       pz(2) = zi - z2
              
       fi = f(1,1,1)
     &    + ( a112*px(1)*py(2) + a121*px(2)*py(1) + 
     &        a122*px(1)*py(1)                    )*pz(2)
     &    + ( a211*px(2)*py(2) + a212*px(1)*py(2) + 
     &        a221*px(2)*py(1) + a222*px(1)*py(1) )*pz(1)
     
       fxi   = ( a112*py(2) + a121*py(1) + a122*py(1) )*pz(2)
     &       + ( a211*py(2) + a212*py(2) + a221*py(1) + 
     &           a222*py(1) )*pz(1)

       fyi   = ( a112*px(1) + a121*px(2) + a122*px(1) )*pz(2)
     &       + ( a211*px(2) + a212*px(1) + a221*px(2) +
     &           a222*px(1) )*pz(1)

       fzi   = ( a112*px(1) + a211*px(2) + a212*px(1) )*py(2)
     &       + ( a121*px(2) + a122*px(1) + a221*px(2) +
     &           a222*px(1) )*py(1)

       fxyi  = (        a112 + a121 + a122 )*pz(2)
     &       + ( a211 + a212 + a221 + a222 )*pz(1)

       fxzi  = (        a112 + a211 + a212 )*py(2)
     &       + ( a121 + a122 + a221 + a222 )*py(1)

       fyzi  = ( a112 + a122 + a212 + a222 )*px(1)
     &       + (        a121 + a211 + a221 )*px(2)

       fxyzi =        a112 + a121 + a122
     &       + a211 + a212 + a221 + a222
       
c***********************************************************************
c     Back to main:
c***********************************************************************
       
       return 
       
       end

