       subroutine bpai1d(x,y,xi,yi,yxi,yxxi)
	  
c***********************************************************************
c      Barycentric Parabolic Interpolation 1D
c      Written by Orlando Camargo Rodriguez
c      orodrig@ualg.pt
c      Universidade do Algarve
c      Physics Department
c      Signal Processing Laboratory
c      Gambelas, Wed Jun 15 18:00:00 WEST 2011
c****&******************************************************************

       real*8 x(3),y(3)
       real*8 px(2),sx(2)
       real*8 a2,a3
       real*8 xi,x1,x2,x3
       real*8 yi,y1,y2,y3
       real*8 yxi,yxxi
       
c***********************************************************************
       
       x1 = x(1)
       x2 = x(2)
       x3 = x(3)
       
       y1 = x(1)
       y2 = x(2)
       y3 = x(3)

       px(1) = ( x2 - x1 )*( x2 - x3 )
       px(2) = ( x3 - x1 )*( x3 - x2 )
       
       a2 = ( y2 - y1 )/px(1)
       a3 = ( y3 - y1 )/px(2)

       px(1) = ( xi - x1 )*( xi - x3 )
       px(2) = ( xi - x1 )*( xi - x2 )
       
       sx(1) = 2*xi - x1 - x3
       sx(2) = 2*xi - x1 - x2
       
         yi = y1 + a2*px(1) +   a3*px(2)
        yxi =      a2*sx(1) +   a3*sx(2)
       yxxi =  2*( a2       +   a3 )
       
c***********************************************************************
c     Back to main:
c***********************************************************************
       
       return 
       
       end
