       subroutine calaad(ctitle,nthtas,nphi,iad)

c***********************************************************************
c      CALAAD.FOR
c      CALculation of Amplitudes And Delays
c      Written by Orlando Camargo Rodriguez
c      Faro, Sat Jan 14 15:52:37 WET 2017
c      This version works only for a vertical array
c***********************************************************************

c      Include global (common) variables:

       include 'global.for'

c      Define local variables:

       character(len=128) header
       character(len=60 ) ctitle
       character(len=8  ) v1
       character(len=8  ) rayvar
       character(len=7  ) cvii
       character(len=6  ) cvi
       character(len=5  ) cv
       character(len=4  ) civ
       character(len=3  ) ciii
       character(len=2  ) cii
       character(len=1  ) ci

       integer*4 irefl(np)
       integer*4 kseg(352),kaux(352)
       
       integer*4 i,iad,ii,imax
       integer*4 j,k,l,le,ll,lll
       integer*4 nthtas,nphi,na,nseg
       integer*4 mrows,ncols
       
       real*8 raydata(7)       
       real*8 irefra(nthtas),iorefl(nthtas)
       real*8 isrefl(nthtas),ibrefl(nthtas)
       real*8 rh(3)
       real*8 thetai,ctheta,phii
       real*8 dx,dy,dz
       real*8 dummy

       complex*16 pray

c***********************************************************************

      omega = 2*pi*freqx
      dtheta = dtheta*pi/180.0
      
      na = 0
      
      rayvar = 'e0000000'

      le = 0
      
      kseg(1) = 1

c***********************************************************************
c    Start writing the OUTFIL:
c***********************************************************************

c     96 characters: 

      header = 'Signal Processing LABoratory: TRACEO3D 
     & acoustic ray tracing program - Eigenrays'
     
      header(117:124) = char(ichar(' '))
      header(125:126) = char(0) // char(1)
       
      write(header(127:128),'(a)') int(19785,kind=2)

      open(unit=outfil,file='aad.mat',form='unformatted',
     & access='stream')
     
c     Open the file and write the header:

      do i = 1, 16
         j = 8*(i-1) + 1
         write(outfil) header(j:j+7)
      end do

c     Write the array coordinates:

      if ((nxa*nya*nza).eq.0) then
      na = max(nxa,nya,nza)
      end if

      v1 = 'xarray3d'

      if (na.ne.0) then
      ncols = na
      else
      ncols = nxa
      end if
      
      call dtelrv(outfil,1,ncols,8,v1,xarray)

      v1 = 'yarray3d'

      if (na.ne.0) then
      ncols = na
      else
      ncols = nya
      end if
    
      call dtelrv(outfil,1,ncols,8,v1,yarray)

      v1 = 'zarray3d'

      if (na.ne.0) then
      ncols = na
      else
      ncols = nza
      end if

      call dtelrv(outfil,1,ncols,8,v1,zarray)

c***********************************************************************
c      Solve the EIKonal set of EQuations,
c      Solve the DYNamic set of EQuations,
c      Get eigenrays:
c***********************************************************************
       
       do ii = 1,nphi

          phii = phi(ii)*pi/180.0
       
       do i  = 1,nthtas

           thetai = -thetas(i)*pi/180.0

           ctheta = abs( cos( thetai ) )

c          Trace a ray as long as it is neither 90 or -90:

           if (ctheta.gt.1.0e-7) then

           call seikeq(thetai,phii,imax,irefl)
	   call sdyneq(thetai,phii,imax,irefl)

c=======================================================================
c=======================================================================
c          Get indexes of ray segments:
c=======================================================================
c=======================================================================

c	   No refractions/no reflections:

	   if ((nrefl.eq.0).and.(nrefr.eq.0)) then
	
	   kseg(2) = imax
	   nseg    = 2
c-----------------------------------------------------------------------
c	   No refractions/some reflections:

	   elseif ((nrefl.ne.0).and.(nrefr.eq.0)) then

	   do k = 1,nrefl

	      kseg(k+1) = krefl(k)

	   end do

	   if (krefl(nrefl).lt.imax) then
	   kseg(nrefl+2) = imax
	   nseg = nrefl + 2
	   else
	   nseg = nrefl + 1
	   end if
c-----------------------------------------------------------------------
c	   Some refractions/no reflections:

	   elseif ((nrefl.eq.0).and.(nrefr.ne.0)) then

	   do k = 1,nrefr

	      kseg(k+1) = krefr(k)
	
	   end do
	
	   if (krefr(nrefr).lt.imax) then
	   kseg(nrefr+2) = imax
	   nseg = nrefr + 2
	   else
	   nseg = nrefr + 1
	   end if
c-----------------------------------------------------------------------
c	   Some refractions/some reflections:

	   else
	
	   kaux(1) = 1
	
	   do k = 1,nrefl

	      kaux(k+1) = krefl(k)
	
	   end do

	   do k = 1,nrefr

	      kaux(nrefl+k+1) = krefr(k)
	
	   end do
	
	   nseg = nrefl+nrefr+1

	   call sorti(nseg,kaux,kseg)

	   if (kseg(nseg).lt.imax) then
	   nseg = nseg + 1
	   kseg(nseg) = imax
	   end if
	
c-----------------------------------------------------------------------
           end if
c	   if ((nrefl.eq.0).and.(nrefr.eq.0)) then

c=======================================================================
c=======================================================================
c          Eigenray search:
c=======================================================================
c=======================================================================

c          Linear array:

	   if (iad.eq.1) then

c***********************************************************************

 	      do l = 1,na

	      rh(1) = xarray(l)
	      rh(2) = yarray(l)
	      rh(3) = zarray(l)

	      dx = x(imax) - rh(1)
	      dy = y(imax) - rh(2)
	      dz = z(imax) - rh(3)
	      
	      dimax = sqrt( dx*dx + dy*dy + dz*dz )
	      
c-----------------------------------------------------------------------

	      if (dimax.lt.miss)then
	      
	      leig = leig + 1

c=======================================================================
c                Yes: this is ugly, but it works!!!
		 
		 if (leig.lt.10) then
		 write (ci, '(I1)'), leig
		 rayvar(8:8) = ci
		 elseif ((leig.ge.10).and.(leig.lt.100)) then
		 write (cii, '(I2)'), leig
		 rayvar(7:8) = cii
		 elseif ((leig.ge.100).and.(leig.lt.1000))  then
		 write (ciii, '(I3)'), leig
		 rayvar(6:8) = ciii
		 elseif ((leig.ge.1000).and.(leig.lt.10000))  then
		 write (civ, '(I4)'), leig
		 rayvar(5:8) = civ
		 elseif ((leig.ge.1000).and.(leig.lt.10000))  then
		 write (civ, '(I5)'), leig
		 rayvar(4:8) = cv
		 elseif ((leig.ge.10000).and.(leig.lt.100000))  then
		 write (civ, '(I6)'), leig
		 rayvar(3:8) = cvi
		 else
		 write (cvii, '(I7)'), leig
		 rayvar(2:8) = cvii
		 end if
c=======================================================================

		 irefra(leig) = nrefr
		 isrefl(leig) = srefl
		 ibrefl(leig) = brefl
		 iorefl(leig) = orefl
		 
		 raydata(1) = 	         rh( 1 )
		 raydata(2) = 	         rh( 2 )
		 raydata(3) = 	         rh( 3 )
		 raydata(4) = 	        tau(imax)
		 raydata(5) = realpart( amp(imax) )
		 raydata(6) = imagpart( amp(imax) )
		 raydata(7) =        caustc(imax)

		 call dtelrv(outfil,1,7,8,rayvar,raydata)
		 
c=======================================================================
		 
		 end if
		 
c-----------------------------------------------------------------------
	      
	      end do

c***********************************************************************
c          Plane array:

           else

              do j = 1,nxa
	         
		 rh(1) = xarray(j)
		 
	      do k = 1,nya
	      
	         rh(2) = yarray(k)
		 
	      do l = 1,nza
	      
	         rh(3) = zarray(l)

c#######################################################################
		 
		 do ll = 1,ncpa
		 
		 dx = x(imax) - rh(1)
		 dy = y(imax) - rh(2)
		 dz = z(imax) - rh(3)

                 dimax = sqrt( dx*dx + dy*dy + dz*dz )
c:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
		 
		 if (dimax.le.miss) then
		 
		 leig = leig + 1

c=======================================================================
c                Yes: this is ugly, but it works!!!
		 
		 if (leig.lt.10) then
		 write (ci, '(I1)'), leig
		 rayvar(8:8) = ci
		 elseif ((leig.ge.10).and.(leig.lt.100)) then
		 write (cii, '(I2)'), leig
		 rayvar(7:8) = cii
		 elseif ((leig.ge.100).and.(leig.lt.1000))  then
		 write (ciii, '(I3)'), leig
		 rayvar(6:8) = ciii
		 elseif ((leig.ge.1000).and.(leig.lt.10000))  then
		 write (civ, '(I4)'), leig
		 rayvar(5:8) = civ
		 elseif ((leig.ge.1000).and.(leig.lt.10000))  then
		 write (cv, '(I5)'), le
		 rayvar(4:8) = cv
		 elseif ((leig.ge.10000).and.(leig.lt.100000))  then
		 write (cvi, '(I6)'), leig
		 rayvar(3:8) = cvi
		 else
		 write (cvii, '(I7)'), leig
		 rayvar(2:8) = cvii
		 end if
c=======================================================================

		 irefra(leig) = nrefr
		 isrefl(leig) = srefl
		 ibrefl(leig) = brefl
		 iorefl(leig) = orefl
		 
		 raydata(1) = 	         rh( 1 )
		 raydata(2) = 	         rh( 2 )
		 raydata(3) = 	         rh( 3 )
		 raydata(4) = 	        tau(imax)
		 raydata(5) = realpart( amp(imax) )
		 raydata(6) = imagpart( amp(imax) )
		 raydata(7) =        caustc(imax)

		 call dtelrv(outfil,1,7,8,rayvar,raydata)

c=======================================================================
		 
		 end if
		 
c:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

		 end do

c#######################################################################

	      end do
	      end do
	      end do

c***********************************************************************

	   end if
c	   if (iad.eq.1) then

c=======================================================================
c=======================================================================
c          End of calculations
c=======================================================================
c=======================================================================

c***********************************************************************
c          if (ctheta.gt.1.0e-7) then
           end if

       end do
       
       end do
       
       v1 = 'nerays3d'

       dummy = le
       
       call dtelrv(outfil,1,1,8,v1,dummy)
       
c***********************************************************************
c      Write number of refractions and reflections:

       v1 = 'refrctns'
	   
       call dtelrv(outfil,1,leig,8,v1,irefra)

       v1 = 'sreflect'
	   
       call dtelrv(outfil,1,leig,8,v1,isrefl)
       
       v1 = 'breflect'
	   
       call dtelrv(outfil,1,leig,8,v1,ibrefl)
       
       v1 = 'oreflect'
	   
       call dtelrv(outfil,1,leig,8,v1,iorefl)
       
c***********************************************************************

5000   format(i6)

c***********************************************************************
c      Close the OUTFIL:
c***********************************************************************

       close(outfil)

c***********************************************************************
c     Back to main:
c***********************************************************************

      return
      
      end
