       subroutine calari(ctitle,nthtas,nphi)
       
c***********************************************************************
c      CALARI.FOR
c      CALculation of All Ray Information
c      Written by Orlando Camargo Rodriguez
c      Faro, Thu Oct 25 20:46:33 WEST 2012
c***********************************************************************

c      Include global (common) variables:

       include 'global.for'

c      Define local variables:

       character(len=128) header
       character(len=60 ) ctitle
       character(len=8  ) v1
       character(len=8  ) rayvar
       character(len=5  ) cv
       character(len=4  ) civ
       character(len=3  ) ciii
       character(len=2  ) cii
       character(len=1  ) ci

       integer*4 irefl(np)
       
       integer*4 i,ii,imax,j,l
       integer*4 nthtas,nphi
       
       real*8 raydata(np,7)
       real*8 thetai,ctheta,phii

c***********************************************************************

      header = 'Signal Processing LABoratory: TRACEO3D
     & acoustic ray tracing program - All Ray Information'
     
      header(117:124) = char(ichar(' '))
      header(125:126) = char(0) // char(1)
       
      write(header(127:128),'(a)') int(19785,kind=2)
      
      rayvar = 'ray00000'

      open(unit=outfil,file='ari.mat',form='unformatted',
     & access='stream')
     
c     Open the file and write the header:

      do i = 1, 16
         j = 8*(i-1) + 1
         write(outfil) header(j:j+7)
      end do

c     Write the angles:
           
      v1 = 'ray_thts'
	   
      call dtelrv(outfil,1,nthtas,8,v1,thetas)
      
      v1 = 'ray_phis'
	   
      call dtelrv(outfil,1,nphi,8,v1,phi)
      
      l = 0
       
c***********************************************************************
c      Solve the EIKonal set of EQuations:
c***********************************************************************
       
       do ii = 1,nphi
       
          phii = phi(ii)*pi/180.0
       
      do i  = 1,nthtas

           thetai = -thetas(i)*pi/180.0

           ctheta = abs( cos( thetai ) )

c          Trace a ray as long as it is neither 90 or -90:

           if (ctheta.gt.1.0e-7) then

           call seikeq(thetai,phii,imax,irefl)
	   call sdyneq(thetai,phii,imax,irefl)
	   
c          Yes: this is ugly, but it works!!!
	   
	   l = l + 1
	   
	   if (l.lt.10) then
	   write (ci, '(I1)'), l
	   rayvar(8:8) = ci
	   elseif ((l.ge.10).and.(l.lt.100)) then
	   write (cii, '(I2)'), l
	   rayvar(7:8) = cii
	   elseif ((l.ge.100).and.(l.lt.1000))  then
	   write (ciii, '(I3)'), l
	   rayvar(6:8) = ciii
	   elseif ((l.ge.1000).and.(l.lt.10000))  then
	   write (civ, '(I4)'), l
	   rayvar(5:8) = civ
	   else
	   write (cv, '(I5)'), l
	   rayvar(4:8) = cv
	   end if 
	   
c          Write all ray information:

	   do k = 1,imax
	   raydata(k,1) =             x(k)
	   raydata(k,2) =             y(k)
	   raydata(k,3) =             z(k)
	   raydata(k,4) =           tau(k)
	   raydata(k,5) = realpart( amp(k) )
	   raydata(k,6) = imagpart( amp(k) )
	   raydata(k,7) =        caustc(k)
	   end do
	   
           call dtelm7(outfil,7,imax,8,rayvar,raydata)

           end if
c          if (ctheta.gt.1.0e-7) then

       end do
       
       end do

c***********************************************************************

5000   format(i6)

c***********************************************************************
c      Close the RAYFIL:

       close(outfil)

c***********************************************************************
c     Back to main:
c***********************************************************************

      return
      
      end
