       subroutine caleig(ctitle,nthtas,nphi,iad)

c***********************************************************************
c      CALEIG.FOR
c      CALculation of EIGenrays
c      Written by Orlando Camargo Rodriguez
c      Gambelas, Fri Apr 22 18:44:03 WEST 2016
c***********************************************************************

c      Include global (common) variables:

       include 'global.for'

c      Define local variables:

       character(len=128) header
       character(len=60 ) ctitle
       character(len=8  ) v1
       character(len=8  ) rayvar,segrfl,segrfr
       character(len=5  ) cv
       character(len=4  ) civ
       character(len=3  ) ciii
       character(len=2  ) cii
       character(len=1  ) ci

       integer*4 irefl(np)
       
       integer*4 i,ii,imax,j,k
       integer*4 l,leig,ll
       integer*4 nthtas,nphi,na
       integer*4 mrows,ncols
       
       real*8 raydata(np,7)
       real*8 irefra(nthtas),iorefl(nthtas)
       real*8 isrefl(nthtas),ibrefl(nthtas)
       real*8 rh(3)
       real*8 thetai,ctheta,phii
       real*8 dx,dy,dz,dimax
       real*8 sold,snew,idupl
       real*8 dummy

c***********************************************************************

      rayvar = 'e0000000'
      segrfl = 'rfl00000'
      segrfr = 'rfr00000'

      leig = 0
      na   = 0

c***********************************************************************

      header = 'Signal Processing LABoratory: TRACEO3D 
     & acoustic ray tracing program - Eigenrays'
     
      header(117:124) = char(ichar(' '))
      header(125:126) = char(0) // char(1)
       
      write(header(127:128),'(a)') int(19785,kind=2)
      
      open(unit=outfil,file='eig.mat',form='unformatted',
     & access='stream')
     
c     Open the file and write the header:

      do i = 1, 16
         j = 8*(i-1) + 1
         write(outfil) header(j:j+7)
      end do

c***********************************************************************
c     Write the array coordinates:
c***********************************************************************

      if ((nxa*nya*nza).eq.0) then
      na = max(nxa,nya,nza)
      end if

      v1 = 'xarray3d'

      if (na.ne.0) then
      ncols = na
      else
      ncols = nxa
      end if
      
      call dtelrv(outfil,1,ncols,8,v1,xarray)

      v1 = 'yarray3d'

      if (na.ne.0) then
      ncols = na
      else
      ncols = nya
      end if
    
      call dtelrv(outfil,1,ncols,8,v1,yarray)

      v1 = 'zarray3d'

      if (na.ne.0) then
      ncols = na
      else
      ncols = nza
      end if

      call dtelrv(outfil,1,ncols,8,v1,zarray)

c***********************************************************************
c      Solve the EIKonal set of EQuations:
c***********************************************************************
       
       do ii = 1,nphi
       
          phii = phi(ii)*pi/180.0
          sold = 0.0
	  
      do i  = 1,nthtas

           thetai = -thetas(i)*pi/180.0

           ctheta = abs( cos( thetai ) )

c          Trace a ray as long as it is neither 90 or -90:

           if (ctheta.gt.1.0e-7) then

           call seikeq(thetai,phii,imax,irefl)
	   call sdyneq(thetai,phii,imax,irefl)

c=======================================================================
c=======================================================================
c          Eigenray search:
c=======================================================================
c=======================================================================

c          Linear array:

	   if (iad.eq.1) then
 	      
	      do l = 1,na

	      rh(1) = xarray(l)
	      rh(2) = yarray(l)
	      rh(3) = zarray(l)
	      
	      dx = x(imax) - rh(1)
	      dy = y(imax) - rh(2)
	      dz = z(imax) - rh(3)
	      
	      dimax = sqrt( dx*dx + dy*dy + dz*dz )

c-----------------------------------------------------------------------

	      if (dimax.lt.miss)then
	      
	      leig = leig + 1

c=======================================================================
c	      Yes: this is ugly, but it works!!!
	
	      if (leig.lt.10) then
	      write (ci, '(I1)'), leig
	      rayvar(8:8) = ci
	      segrfl(8:8) = ci
	      segrfr(8:8) = ci
	      elseif ((leig.ge.10).and.(leig.lt.100)) then
	      write (cii, '(I2)'), leig
	      rayvar(7:8) = cii
	      segrfl(7:8) = cii
	      segrfr(7:8) = cii
	      elseif ((leig.ge.100).and.(leig.lt.1000))  then
	      write (ciii, '(I3)'), leig
	      rayvar(6:8) = ciii
	      segrfl(6:8) = ciii
	      segrfr(6:8) = ciii
	      elseif ((leig.ge.1000).and.(leig.lt.10000))  then
	      write (civ, '(I4)'), leig
	      rayvar(5:8) = civ
	      segrfl(5:8) = civ
	      segrfr(5:8) = civ
	      else
	      write (cv, '(I5)'), leig
	      rayvar(4:8) = cv
	      segrfl(4:8) = cv
	      segrfr(4:8) = cv
	      end if
c=======================================================================

	      irefra(leig) = nrefr
	      isrefl(leig) = srefl
	      ibrefl(leig) = brefl
	      iorefl(leig) = orefl

	      do ll = 1,imax
	      raydata(ll,1) =  	   x(ll)
	      raydata(ll,2) =  	   y(ll)
	      raydata(ll,3) =  	   z(ll)
	      raydata(ll,4) =  	 tau(ll)
	      raydata(ll,5) = realpart( amp(ll) )
	      raydata(ll,6) = imagpart( amp(ll) )
	      raydata(ll,7) =        caustc(ll)
	      end do
	
	      call dtelm7(outfil,7,imax,8,rayvar,raydata)
	      
	      end if
c-----------------------------------------------------------------------
	      
	      end do

c***********************************************************************
c          Plane array:
	   
	   else
	   
	      do j = 1,nxa
	         
		 rh(1) = xarray(j)
		 
	      do k = 1,nya
	      
	         rh(2) = yarray(k)
		 
	      do l = 1,nza
	      
	         rh(3) = zarray(l)
		 
		 dx = x(imax) - rh(1)
		 dy = y(imax) - rh(2)
		 dz = z(imax) - rh(3)
	
		 dimax = sqrt( dx*dx + dy*dy + dz*dz )

c-----------------------------------------------------------------------

	      if (dimax.lt.miss)then
	      
	      leig = leig + 1

c=======================================================================
c	      Yes: this is ugly, but it works!!!
	
	      if (leig.lt.10) then
	      write (ci, '(I1)'), leig
	      rayvar(8:8) = ci
	      segrfl(8:8) = ci
	      segrfr(8:8) = ci
	      elseif ((leig.ge.10).and.(leig.lt.100)) then
	      write (cii, '(I2)'), leig
	      rayvar(7:8) = cii
	      segrfl(7:8) = cii
	      segrfr(7:8) = cii
	      elseif ((leig.ge.100).and.(leig.lt.1000))  then
	      write (ciii, '(I3)'), leig
	      rayvar(6:8) = ciii
	      segrfl(6:8) = ciii
	      segrfr(6:8) = ciii
	      elseif ((leig.ge.1000).and.(leig.lt.10000))  then
	      write (civ, '(I4)'), leig
	      rayvar(5:8) = civ
	      segrfl(5:8) = civ
	      segrfr(5:8) = civ
	      else
	      write (cv, '(I5)'), leig
	      rayvar(4:8) = cv
	      segrfl(4:8) = cv
	      segrfr(4:8) = cv
	      end if
c=======================================================================

	      irefra(leig) = nrefr
	      isrefl(leig) = srefl
	      ibrefl(leig) = brefl
	      iorefl(leig) = orefl

	      do ll = 1,imax
	      raydata(ll,1) =  	   x(ll)
	      raydata(ll,2) =  	   y(ll)
	      raydata(ll,3) =  	   z(ll)
	      raydata(ll,4) =  	 tau(ll)
	      raydata(ll,5) = realpart( amp(ll) )
	      raydata(ll,6) = imagpart( amp(ll) )
	      raydata(ll,7) =        caustc(ll)
	      end do
	
	      call dtelm7(outfil,7,imax,8,rayvar,raydata)
	      
              end if
c-----------------------------------------------------------------------

	     end do
	     end do
	     end do

	   end if
c	   if (iad.eq.1) then

c=======================================================================
c=======================================================================
c          End of search
c=======================================================================
c=======================================================================

           end if
c          if (ctheta.gt.1.0e-7) then

       end do
       
       end do
       
c***********************************************************************
c      Write the number of eigenrays:
       
       v1 = 'nerays3d'

       dummy = leig
       
       call dtelrv(outfil,1,1,8,v1,dummy)

c***********************************************************************
c      Write number of refractions and reflections:

       v1 = 'refrctns'
	   
       call dtelrv(outfil,1,leig,8,v1,irefra)

       v1 = 'sreflect'
	   
       call dtelrv(outfil,1,leig,8,v1,isrefl)
       
       v1 = 'breflect'
	   
       call dtelrv(outfil,1,leig,8,v1,ibrefl)
       
       v1 = 'oreflect'
	   
       call dtelrv(outfil,1,leig,8,v1,iorefl)

c***********************************************************************

5000   format(i6)

c***********************************************************************
c      Close the OUTFIL:

       close(outfil)

c***********************************************************************
c     Back to main:
c***********************************************************************

      return
      
      end
