       subroutine cvals3(nx,ny,nz,tabx,taby,tabz,tabc,xi,yi,zi,ci,
     & cxi,cyi,czi,cxxi,cyyi,czzi,cxyi,cxzi,cyzi)

c***********************************************************************
c      CVALS3.FOR
c      (3D) Interpolation of sound speed and its derivatives
c      Written by Orlando Camargo Rodriguez
c      Faro, Dom Jul 28 15:06:35 WEST 2019
c      Obrigado Rogerio!
c****&******************************************************************

c      Include global (common) variables:

       include 'globli.for'

c      Define local variables:
       
       integer i, j, k, nx, ny, nz, il
       integer ii,jj,kk

       real*8 tabc(nc03d,nc03d,nc03d)
       real*8 fc(4,4,4)
       real*8 fl(2,2,2)
       
       real*8 tabx(nx),taby(ny),tabz(nz)
       real*8 xc(4),yc(4),zc(4)
       real*8 xl(2),yl(2),zl(2)
       
       real*8   xi,  yi, zi, ci
       real*8  cxi, cyi, czi
       real*8 cxxi,cyyi,czzi
       real*8 cxyi,cxzi,cyzi
       real*8 cxyzi

c-----------------------------------------------------------------------

       il   = 0
       cxxi = 0.0
       cyyi = 0.0
       czzi = 0.0
       
c-----------------------------------------------------------------------

       if (xi.le.tabx(2)) then
          i  = 1
	  il = 1
       else if (xi.ge.tabx(nx-1)) then
          i = nx - 1
	  il = 1
       else 
          call brcket(nx,tabx,xi,i)
       end if
       
c-----------------------------------------------------------------------

       if (yi.le.taby(2)) then
          j  = 1
	  il = 1
       else if (yi.ge.taby(ny-1)) then
          j = ny - 1
	  il = 1
       else 
          call brcket(ny,taby,yi,j)
       end if

c-----------------------------------------------------------------------

       if (zi.le.tabz(2)) then
          k  = 1
	  il = 1
       else if (zi.ge.tabz(nz-1)) then
          k = nz - 1
	  il = 1
       else 
          call brcket(nz,tabz,zi,k)
       end if

c-----------------------------------------------------------------------
      
       if (il.eq.1) then
       
       xl(1) = tabx( i )
       xl(2) = tabx(i+1)
       
       yl(1) = taby( j )
       yl(2) = taby(j+1)
       
       zl(1) = tabz( k )
       zl(2) = tabz(k+1)
       
       fl(1,1,1) = tabc( k , j , i )
       fl(1,1,2) = tabc( k , j ,i+1)
       fl(1,2,1) = tabc( k ,j+1, i )
       fl(1,2,2) = tabc( k ,j+1,i+1)
       
       fl(2,1,1) = tabc(k+1, j , i )
       fl(2,1,2) = tabc(k+1, j ,i+1)
       fl(2,2,1) = tabc(k+1,j+1, i )
       fl(2,2,2) = tabc(k+1,j+1,i+1)
       
       call blii3d(xl,yl,zl,fl,xi,yi,zi,ci,cxi,cyi,czi,
     & cxyi,cxzi,cyzi,cxyzi)

       else
       
       xc(1) = tabx(i-1)
       xc(2) = tabx( i )
       xc(3) = tabx(i+1)
       xc(4) = tabx(i+2)
       
       yc(1) = taby(j-1)
       yc(2) = taby( j )
       yc(3) = taby(j+1)
       yc(4) = taby(j+2)
       
       zc(1) = tabz(k-1)
       zc(2) = tabz( k )
       zc(3) = tabz(k+1)
       zc(4) = tabz(k+2)
       
       do kk = 1,4
       
          do jj = 1,4
	  
	     do ii = 1,4
	     
	     fc(kk,jj,ii) = tabc(k+kk-2,j+jj-2,i+ii-2)
	     
	     end do
	     
	  end do
	  
       end do
       
       call bcui3d(xc,yc,zc,fc,xi,yi,zi,ci,cxi,cyi,czi,
     & cxxi,cyyi,czzi,cxyi,cxzi,cyzi)
     
       end if
       
c***********************************************************************
c     Back to main:
c***********************************************************************
       
       return
       	
       end
