       subroutine gcpa(imax,rh,nseg,kseg,ncpa,kcpa)

c***********************************************************************
c      GCPA.FOR
c      Get Closest Point of Approach
c      Written by Orlando Camargo Rodriguez
c      Faro, Wed Oct 31 20:32:06 WET 2012
c***********************************************************************

c      Include global (common) variables:

       include 'global.for'

c      Define local variables:

       integer*4 kseg(nrefrx+nrefl+2),kaux(nrefrx+nreflx+2)
       integer*4 kcpa(101)
       integer*4 imax
       integer*4 icpa,ifail,istrt,ind
       integer*4 k,kstart,kend
       integer*4 nseg,ncpa

       real*8 rh(3)
       real*8 esa(3),esb(3)
       real*8 eab(3),eah(3),ebh(3)
       real*8 n1,pa,pb
       real*8 dummy

c***********************************************************************

       ncpa = 0
       
c***********************************************************************

c      Search the CPA only when you know it exists:

       do k = 1,nseg-1

          kstart = kseg( k )
	  kend   = kseg(k+1)
	  
 	  eab(1) = x(kend) - x(kstart)
	  eab(2) = y(kend) - y(kstart)
	  eab(3) = z(kend) - z(kstart)
	
	  call norm( eab, n1 )
	
	  eab(1) = eab(1)/n1
	  eab(2) = eab(2)/n1
	  eab(3) = eab(3)/n1
	
	  eah(1) = rh(1) - x(kstart)
	  eah(2) = rh(2) - y(kstart)
	  eah(3) = rh(3) - z(kstart)
	
	  call norm( eah, n1 )
	
	  eah(1) = eah(1)/n1
	  eah(2) = eah(2)/n1
	  eah(3) = eah(3)/n1
	
	  ebh(1) = rh(1) - x(kend)
	  ebh(2) = rh(2) - y(kend)
	  ebh(3) = rh(3) - z(kend)
	
	  call norm( ebh, n1 )
	
	  ebh(1) = ebh(1)/n1
	  ebh(2) = ebh(2)/n1
	  ebh(3) = ebh(3)/n1
	
	  call dot( eab, eah, pa )
	  call dot( eab, ebh, pb )

c=======================================================================
c	 Search for the CPA if the product is negative or zero:
 	 if (pa*pb.le.0.0) then

 	 istrt = kstart
 	 ind   = kend
	
 	 call gicpa(istrt,ind,rh,icpa,ifail)

 	 if (ifail.ne.1) then
 	 ncpa = ncpa + 1
	 kcpa(ncpa) = icpa
	 end if

 	 end if
c=======================================================================

       end do

c***********************************************************************
c     Back to main:
c***********************************************************************

      return
      
      end
