       subroutine gicpa(ia,ib,rh,icpa,ifail)
       
c***********************************************************************
c      Get CPA along a ray interval
c      This subroutine is called only when the normal is known to exist
c      Written by Orlando Camargo Rodriguez
c      orodrig@ualg.pt
c      Universidade do Algarve
c      Physics Department
c      Signal Processing Laboratory
c      Faro, Sun Oct 28 10:47:12 WET 2012
c****&******************************************************************

c      Include global (common) variables:

       include 'global.for'

c      Define local variables:

       integer*4 ia,ib,icpa,ifail,im
       integer*4 ntrls

       real*8 rh(3)
       real*8 dah,dbh,dmh
       real*8 dx,dy,dz
       real*8 dummy

c***********************************************************************
       
       ifail = 0 
       
       ntrls = 0

c=======================================================================

c      The CPA is to be search through bisection:
       
       dx = rh(1) - x(ia)
       dy = rh(2) - y(ia)
       dz = rh(3) - z(ia)
       
       dah = sqrt( dx*dx + dy*dy + dz*dz )
       
       dx = rh(1) - x(ib)
       dy = rh(2) - y(ib)
       dz = rh(3) - z(ib)
       
       dbh = sqrt( dx*dx + dy*dy + dz*dz )
       
c=======================================================================
c      Search:

500    im = (ia+ib)/2

       if ((ib-ia).gt.1) then

 	  dx = rh(1) - x(im)
 	  dy = rh(2) - y(im)
 	  dz = rh(3) - z(im)
 
 	  dmh = sqrt( dx*dx + dy*dy + dz*dz )

c         This procedure is repeated until ib = ia + 1:

 	  if (dmh.lt.dah) then
 	  ia  = im
	  dah = dmh
 	  elseif (dmh.lt.dbh) then
 	  ib  = im
	  dbh = dmh
 	  else
	   ntrls = ntrls + 1
	   if (ntrls.gt.201) then
	   ifail = 1
	   print *, 'CPA search failure!'
	   return
	   end if
 	  end if

          goto 500
       
      end if

c-----------------------------------------------------------------------
c      Bisection is finished

       icpa = im
       
c***********************************************************************
c     Back to main:
c***********************************************************************

      return
      
      end
