       subroutine gpress(imax,rh,pray,nseg,kseg)

c***********************************************************************
c      GPRESS.FOR
c      Get acoustic PRessure along the entire ray
c      Written by Orlando Camargo Rodriguez
c      Faro, Qui Ago  1 23:55:48 WEST 2019
c***********************************************************************

c      Include global (common) variables:

       include 'global.for'

c      Define local variables:

       integer*4 kseg(nrefrx+nrefl+2)
       
       integer*4 imax,istrt,ind
       integer*4 k,start,kend
       integer*4 nseg

       real*8 rh(3)
       real*8 esa(3),esb(3)
       real*8 eab(3),eah(3),ebh(3)
       real*8 n1,pa,pb
       real*8 dummy

       complex*16 pray,pray0
       
c***********************************************************************

       pray = (0.0 , 0.0)

c=======================================================================
c=======================================================================
c       Normal search:
c=======================================================================
c=======================================================================

       do k = 1,nseg-1

          kstart = kseg( k )
	  kend   = kseg(k+1)
	  
 	  eab(1) = x(kend) - x(kstart)
	  eab(2) = y(kend) - y(kstart)
	  eab(3) = z(kend) - z(kstart)
	
	  call norm( eab, n1 )
	
	  eab(1) = eab(1)/n1
	  eab(2) = eab(2)/n1
	  eab(3) = eab(3)/n1
	
	  eah(1) = rh(1) - x(kstart)
	  eah(2) = rh(2) - y(kstart)
	  eah(3) = rh(3) - z(kstart)
	
	  call norm( eah, n1 )
	
	  eah(1) = eah(1)/n1
	  eah(2) = eah(2)/n1
	  eah(3) = eah(3)/n1
	
	  ebh(1) = rh(1) - x(kend)
	  ebh(2) = rh(2) - y(kend)
	  ebh(3) = rh(3) - z(kend)
	
	  call norm( ebh, n1 )
	
	  ebh(1) = ebh(1)/n1
	  ebh(2) = ebh(2)/n1
	  ebh(3) = ebh(3)/n1
	
	  call dot( eab, eah, pa )
	  call dot( eab, ebh, pb )

c=======================================================================
c	  Search for the normal if the product is negative or zero:
 	  if (pa*pb.le.0.0) then

 	  istrt = kstart
 	  ind   = kend

	  call gpray(istrt,ind,rh,pray0)
	  
	  pray = pray + pray0

 	  end if
c=======================================================================

       end do

c***********************************************************************
c     Back to main:
c***********************************************************************

      return
      
      end
