       subroutine lpintn(la,lb,p0,p1,p2,li)
	  
c***********************************************************************
c      Line-plane intersection
c      Written by Orlando Camargo Rodriguez
c      orodrig@ualg.pt
c      Universidade do Algarve
c      Physics Department
c      Signal Processing Laboratory
c      Faro, Sun Jan 18 18:30:00 WEST 2009
c***********************************************************************
       
       integer i
       
       real*8 a(3,3)
       real*8 la(3),lb(3),li(3),p0(3),p1(3),p2(3),p(3),y(3)
       real*8 x0,x1,x2
       real*8 y0,y1,y2
       real*8 z0,z1,z2
       real*8 xa,ya,za
       real*8 xb,yb,zb
       real*8 t,u,v
       real*8 d
       
c***********************************************************************
       
       xa = la(1)
       ya = la(2)
       za = la(3)
       
       xb = lb(1)
       yb = lb(2)
       zb = lb(3)
       
       x0 = p0(1)
       y0 = p0(2)
       z0 = p0(3)
       
       x1 = p1(1)
       y1 = p1(2)
       z1 = p1(3)
       
       x2 = p2(1)
       y2 = p2(2)
       z2 = p2(3)
       
       y(1) = xa - x0
       y(2) = ya - y0
       y(3) = za - z0
       
       a(1,1) = xa - xb
       a(1,2) = x1 - x0
       a(1,3) = x2 - x0
       
       a(2,1) = ya - yb
       a(2,2) = y1 - y0
       a(2,3) = y2 - y0
       
       a(3,1) = za - zb
       a(3,2) = z1 - z0
       a(3,3) = z2 - z0
       
       call cramer(a,p,y,d)
       
       t = p(1)
       u = p(2)
       v = p(3)
       
       do i = 1,3
       
          li(i) = la(i) + ( lb(i) - la(i) )*t
       
       end do
       
       return 
        
       end
       
c***********************************************************************
       
