       subroutine raybi(nx,ny,tabx,taby,tabz,itype,la,lb,li)
	  
c***********************************************************************
c      RAY/Boundary Intersection 
c      Written by Orlando Camargo Rodriguez
c      orodrig@ualg.pt
c      Universidade do Algarve
c      Physics Department
c      Signal Processing Laboratory
c      Faro, Sat Jun 18 18:00:00 WEST 2011
c****&******************************************************************

c      Include global (common) variables:

       include 'globli.for'
       
c      Define local variables:

       character*2 itype
       
       integer i,n,nx,ny
       
       real*8 tabz(nbdry,nbdry)
       real*8 tabx(nx),taby(ny)
       real*8 xl(101),yl(101),zl(101),dz(101)
       real*8 la(3),lb(3),li(3)
       real*8 xa,ya,za
       real*8 xb,yb,zb
       real*8 xi,yi,zi
       real*8 dummy
       
c***********************************************************************
       
       xa = la(1)
       ya = la(2)
       za = la(3)
       
       xb = lb(1)
       yb = lb(2)
       zb = lb(3)
       
       if (itype.eq.'FL') then
       
       zi = tabz(1,1)
       
       li(1) = (xb-xa)/(zb-za)*(zi-za) + xa
       li(2) = (yb-ya)/(zb-za)*(zi-za) + ya
       li(3) = zi

       else 
       
       n = 101
       
       call linspc(n,xa,xb,xl)
       call linspc(n,ya,yb,yl)
       call linspc(n,za,zb,zl)
       
       do i = 1,n
          
          xi = xl(i)
          yi = yl(i)
	  
	  call sbdyi(nx,ny,tabx,taby,tabz,itype,xi,yi,zi)
          
          dz(i) = zl(i) - zi


       end do
       
       i = 1 
       
500    if (dz(1)*dz(i).gt.0.0) then 
       
       i = i + 1 

       goto 500
      
       end if
       
       xi = xl(i-1) - dz(i-1)*(xl(i)-xl(i-1))/(dz(i)-dz(i-1))
       yi = yl(i-1) - dz(i-1)*(yl(i)-yl(i-1))/(dz(i)-dz(i-1))

       li(1) = xi
       li(2) = yi
       
       call sbdyi(nx,ny,tabx,taby,tabz,itype,xi,yi,zi)
       
       li(3) = zi
       
       if (abs(li(3)).lt.1.0e-12) then
       li(3) = 0.0
       end if
       
       end if
       
c***********************************************************************
c      Back to main:
c***********************************************************************
       
       return
       
       end
