       subroutine sbdyi(nx,ny,tabx,taby,tabz,itype,xi,yi,zi)

c***********************************************************************
c      SBDYI.FOR
c      Simple BounDarY Interpolation
c      Written by Orlando Camargo Rodriguez
c      Faro, Mon Sep 10 23:49:17 WEST 2012
c****&******************************************************************

c      Include global (common) variables:

       include 'globli.for'
       
c      Define local variables:
       
       character*2 itype 
       
       integer ix,iy,nx,ny
       
       real*8 tabx(nx),taby(ny),tabz(nbdry,nbdry)
       real*8 xc(4),yc(4),zc(4,4)
       real*8 xp(3),yp(3),zp(3,3)
       real*8 xl(2),yl(2),zl(2,2)
       real*8 xi,yi,zi

c***********************************************************************

       if (itype.eq.'2P') then

          call brcket(nx,tabx,xi,ix)
          call brcket(ny,taby,yi,iy)
	  
          zl(1,1) = tabz(iy,ix  )
	  zl(1,2) = tabz(iy,ix+1)
	  
          zl(2,1) = tabz(iy+1,ix  )
	  zl(2,2) = tabz(iy+1,ix+1)

          xl(1) = tabx(ix  )
	  xl(2) = tabx(ix+1)
	  
	  yl(1) = taby(iy  )
          yl(2) = taby(iy+1)

	  call si2p2d(xl,yl,zl,xi,yi,zi)
	  
       elseif (itype.eq.'3P') then
          
          if (xi.le.tabx(2)) then
           ix = 1 
          elseif (xi.ge.tabx(nx-1)) then
           ix = nx - 2 
          else 
           call brcket(nx,tabx,xi,ix)
          end if

          if (yi.le.taby(2)) then
           iy = 1 
          elseif (yi.ge.taby(ny-1)) then
           iy = ny - 2 
          else 
           call brcket(ny,taby,yi,iy)
          end if
          
          xp(1) = tabx(ix  )
          xp(2) = tabx(ix+1)
          xp(3) = tabx(ix+2)
          yp(1) = taby(iy  )
          yp(2) = taby(iy+1)
          yp(3) = taby(iy+2)
          
	  zp(1,1) = tabz(iy,ix  )
	  zp(1,2) = tabz(iy,ix+1)
          zp(1,3) = tabz(iy,ix+2)
	  
	  zp(2,1) = tabz(iy+1,ix  )
	  zp(2,2) = tabz(iy+1,ix+1)
          zp(2,3) = tabz(iy+1,ix+2)
	  
	  zp(3,1) = tabz(iy+2,ix  )
	  zp(3,2) = tabz(iy+2,ix+1)
          zp(3,3) = tabz(iy+2,ix+2)
	  
	  call si3p2d(xp,yp,zp,xi,yi,zi)
       
       elseif (itype.eq.'4P') then

          if (xi.le.tabx(2)) then
           ix = 2 
          elseif (xi.ge.tabx(nx-1)) then
           ix = nx - 2 
          else 
           call brcket(nx,tabx,xi,ix)
          end if
          
          if (yi.le.taby(2)) then
           iy = 2 
          elseif (yi.ge.taby(ny-1)) then
           iy = ny - 2 
          else 
           call brcket(ny,taby,yi,iy)
          end if

          xc(1) = tabx(ix-1)
          xc(2) = tabx(ix  )
          xc(3) = tabx(ix+1)
          xc(4) = tabx(ix+2)
          yc(1) = taby(iy-1)
          yc(2) = taby(iy  )
          yc(3) = taby(iy+1)
          yc(4) = taby(iy+2)
	  
	  zc(1,1) = tabz(iy-1,ix-1)
	  zc(1,2) = tabz(iy-1,ix  )
          zc(1,3) = tabz(iy-1,ix+1)
	  zc(1,4) = tabz(iy-1,ix+2)
	  
	  zc(2,1) = tabz(iy,ix-1)
	  zc(2,2) = tabz(iy,ix  )
          zc(2,3) = tabz(iy,ix+1)
	  zc(2,4) = tabz(iy,ix+2)
	  
	  zc(3,1) = tabz(iy+1,ix-1)
	  zc(3,2) = tabz(iy+1,ix  )
          zc(3,3) = tabz(iy+1,ix+1)
	  zc(3,4) = tabz(iy+1,ix+2)
	  
	  zc(4,1) = tabz(iy+2,ix-1)
	  zc(4,2) = tabz(iy+2,ix  )
          zc(4,3) = tabz(iy+2,ix+1)
	  zc(4,4) = tabz(iy+2,ix+2)
	  
	  call si4p2d(xc,yc,zc,xi,yi,zi)

       else

           zi = tabz(1,1)
	   
       end if

c***********************************************************************
c      Back to main:
c***********************************************************************

       return
       
       end
