       subroutine si2p2d(x,y,z,xi,yi,zi)
	  
c***********************************************************************
c      Simple barycentric Interpolation with 2 Points / 2D
c      Written by Orlando Camargo Rodriguez
c      orodrig@ualg.pt
c      Universidade do Algarve
c      Physics Department
c      Signal Processing Laboratory
c      Faro, Tue Sep 11 00:19:52 WEST 2012
c***********************************************************************

       real*8 z(2,2)
       real*8 x(2),y(2)
       real*8 px(2),py(2)
       real*8 zi
       real*8 xi,x1,x2
       real*8 yi,y1,y2
       real*8 a12,a21,a22
       real*8 pxy
       
c***********************************************************************
       
       x1 = x(1)
       x2 = x(2)
       
       y1 = y(1)
       y2 = y(2)

       pxy = (x2-x1)*(y2-y1)
       
       a12 = ( z(1,1) - z(1,2) )/pxy
       a21 = ( z(1,1) - z(2,1) )/pxy
       a22 = ( z(2,2) - z(1,1) )/pxy
       
       px(1) = xi - x1
       px(2) = xi - x2
       
       py(1) = yi - y1
       py(2) = yi - y2
       
       zi = z(1,1)+a12*px(1)*py(2)+a21*px(2)*py(1)+a22*px(1)*py(1)

c***********************************************************************
c     Back to main:
c***********************************************************************
       
       return 
       
       end

