       subroutine si4p2d(x,y,z,xi,yi,zi)
	  
c***********************************************************************
c      Simple barycentric Interpolation with 4 Points / 2D
c      Written by Orlando Camargo Rodriguez
c      orodrig@ualg.pt
c      Universidade do Algarve
c      Physics Department
c      Signal Processing Laboratory
c      Faro, Mon Sep 10 23:15:23 WEST 2012
c***********************************************************************

       integer i,j
       
       real*8 z(4,4),a(4,4)
       real*8 x(4),y(4)
       real*8 px(4),py(4)
       real*8 xi,x1,x2,x3,x4
       real*8 yi,y1,y2,y3,y4
       real*8 zi

       x1 = x(1)
       x2 = x(2)
       x3 = x(3)
       x4 = x(4)
       
       y1 = y(1)
       y2 = y(2)
       y3 = y(3)
       y4 = y(4)
       
       px(1) = (x1-x2)*(x1-x3)*(x1-x4)
       px(2) = (x2-x1)*(x2-x3)*(x2-x4)
       px(3) = (x3-x1)*(x3-x2)*(x3-x4)
       px(4) = (x4-x1)*(x4-x2)*(x4-x3)
       
       py(1) = (y1-y2)*(y1-y3)*(y1-y4)
       py(2) = (y2-y1)*(y2-y3)*(y2-y4)
       py(3) = (y3-y1)*(y3-y2)*(y3-y4)
       py(4) = (y4-y1)*(y4-y2)*(y4-y3)
      
c      Yes, a(1,1) is zero, but using the do loops 
c      shortens the code. 

       do j = 1,4
       
          do i = 1,4
       
             a(j,i) = (z(j,i) - z(1,1))/( py(j)*px(i) )

          end do

       end do
       
       px(1) = (xi-x2)*(xi-x3)*(xi-x4)
       px(2) = (xi-x1)*(xi-x3)*(xi-x4)
       px(3) = (xi-x1)*(xi-x2)*(xi-x4)
       px(4) = (xi-x1)*(xi-x2)*(xi-x3)
       
       py(1) = (yi-y2)*(yi-y3)*(yi-y4)
       py(2) = (yi-y1)*(yi-y3)*(yi-y4)
       py(3) = (yi-y1)*(yi-y2)*(yi-y4)
       py(4) = (yi-y1)*(yi-y2)*(yi-y3)
       
       zi = z(1,1)

       do j = 1,4
       
          do i = 1,4
       
              zi = zi + a(j,i)*px(i)*py(j)
	    
          end do

       end do

c***********************************************************************
c     Back to main:
c***********************************************************************
       
       return 
       
       end
       
